function [X_hat,I]= seasonal_analysis(X,m)
%Seasonal Analysis 季节分析法去除周期性
% @m 季节周期
% @X 原始时间序列
% @S 趋势项
% @X_hat 季节分析法去除周期性后时间序列
% @I 季节指数

if mod(length(X),m)==0
    n=length(X)/m;
    X_jbar=zeros(m,1);
    I=zeros(m,1);
    S_0=zeros(m,1);
    X_bar=1/(n*m)*sum(X);
    for j=1:m
        X_jbar(j)=1/n*sum(X((j-1)*n+1:(j-1)*n+n));
        I(j)=X_jbar(j)/X_bar;
        S_0(j)=X_bar*I(j);
    end
    S=repmat(S_0,n,1);
    X_hat=X-S;
else
    disp('使用季节分析法去除周期性时时间序列长度不能被周期整除');
    disp('请修正后重新尝试喔,宝儿~');
end
end